--Zachary Randall
--CS 472
--Project 2
--October 27, 2003
with Ada.Text_IO;
--main body definition
procedure Primes is
    --
    MaxTasks : constant Integer := 11;
    --
    package Int_IO is new Ada.Text_IO.Integer_IO( Integer );
    --
    task type FilterType is
        entry Initialize( Position : Integer; Divisor : Integer );
    end FilterType;
    --
    task type BufferType( Capacity : Positive ) is
        entry Enqueue( N : in  Integer );
        entry Dequeue( N : out Integer );
        entry Size(    S : out Integer );
    end BufferType;
	--
	--print function to keep output looking neat
	Protected Type Manager is
		--prints out FilterTask start message
		procedure FilterStart(P : in Integer; D : in Integer);
		--prints out FilterTask terminate message
		procedure FilterTermination(I : in Integer);
		--prints out any other output statements
		procedure Print(S : in String );
	end Manager;
    --
    -- Local variables for main procedure
    --
    Filter : array( 1..MaxTasks ) of FilterType;
    Buffer : array( 1..MaxTasks ) of BufferType( 5 );
    --
    Primes : BufferType( 200 );
    --
	--highest integer to check for prime status
	HighInt: Integer := 1000;
    --
	--used by main function to store number of ints in primes buffer
	I: Integer;
	--used to dequeue prime number from primes buffer
	P: Integer;
	--
	--indicates that all buffers are empty and primes have been stored in primes buffer
	PrimesFinished: Boolean;
	--
	--FilterType is used to check an integer to see if it is a prime number
	--Numbers that are prime are either stored in the primes buffer
	--or enqueued into the Buffer array
	task body FilterType is
		P : Integer;
		D : Integer;
		I : Integer;
		S : Integer;
		M : Manager;
	begin
	--		
			I := 1;
			--wait for the initialize statement
			accept Initialize(Position : Integer; Divisor : Integer) do				   
					P := position;
					d := Divisor;
					--print out start message
					m.FilterStart(p, d);
					--if this is the first filter, enqueue the integer into the primes buffer
					if p = 1 then
						Primes.Enqueue(D);
					end if;
			end Initialize;
			
			--get the next int from the buffer
			Buffer(p).Dequeue(i);
			--keep looping until we pull a zero from the buffer
			--zero indicates the end of all input
			while I /= 0 loop
				
				--mod of zero indicates the number was not evenly divisible
				if I mod D /= 0 then
					
					Primes.Size(s);
					--if we're at a filter lower than the 11th filter
					--and the next filter hasn't been initialized
					--initialize it and enqueue the integer into
					--the primes buffer
					If s = P and S < MaxTasks then
						Filter(P + 1).Initialize(Position => P + 1, Divisor => I);
						Primes.Enqueue(i);
					--if we're the 11th filter, just enqueue the number in primes
					elsif P = MaxTasks then
						Primes.Enqueue(i);
					--otherwise, move the integer into the next buffer
					else
						Buffer(P + 1).Enqueue(I);		
					end if;
				end if;
				--get the next int from the buffer
				Buffer(P).Dequeue(i);
			end loop;
			--if this is any filter other than the last
			--pass the zero on to the next buffer to indicate
			-- the end of input
			if P < MaxTasks then
				Buffer(P + 1).Enqueue(0);
			--otherwise indicate that all processing is finished
			--by setting primesfinished to true
			else 
				PrimesFinished := true;
			end if;
			--print out the termination message
			M.FilterTermination(P);
			
	--
	end FilterType;
    --
	--buffer used to represent a simple queue ADT.
	task body BufferType is
		--array of integers
		Queue : array(1..Capacity) of Integer;
		NumberOfElements : Integer;
		M: Manager;
		Finished : Boolean;
		--
	begin
		--
		Finished := false;
		NumberOfElements := 0;
		M.Print("Buffer task started...");
		--
		--loop until finished variable set to true;
		while Finished = false loop
			select
			--  enqueue ints when total # of elements
			--  is less than the capacity
				when NumberOfElements < Capacity =>
					accept Enqueue( N : in  Integer ) do
					    NumberOfElements := NumberOfElements + 1;
						Queue(NumberOfElements) := N;
					end Enqueue;
			or	
				--dequeue if we have at least one element
				--in the buffer
				when NumberOfElements > 0 =>
					accept Dequeue( N : out Integer ) do
						n := Queue(1);
						NumberOfElements := NumberOfElements - 1;
						--if a zero was just dequeued, our input is finished
						--set finished to true to end the loop
						if n = 0 then
							Finished := true;
						end if;
						--shift remaining elements to the "head" of the queue
						for count IN 1..NumberOfElements loop
							Queue(Count) := Queue(count + 1);
						end loop;
					end Dequeue;
			or
				--return the # of elements currently in the queue
				accept Size(    S : out Integer ) do
					S := NumberOfElements;
				end Size;
			or
				terminate;
			end select;
		end loop;
		--
		--print out terminate statement
		M.Print("Buffer Task terminates");
	end BufferType;

	protected body Manager is
		--
		--print filter start statement
		procedure FilterStart(P : in Integer; D : in Integer) is
		begin
			Ada.Text_IO.Put( "Filter task number " );
			Int_IO.Put(P, 2);
			Ada.Text_IO.Put(" initialized for the prime ");
			Int_IO.put(D, 3);
			Ada.Text_iO.New_Line;
		end FilterStart;
		--
		--print filter termination statement
		procedure FilterTermination(I : in Integer) is
		begin
			Ada.Text_IO.Put("Filter Task number ");
			Int_IO.Put(I, 2);
			Ada.Text_IO.Put(" terminating.");
			Ada.Text_iO.New_Line;
		end FilterTermination;
		--
		--print out any generic statement
		procedure Print (s : in String) is
		begin
		    Ada.Text_IO.Put( S );
			Ada.Text_IO.New_Line;
	    end Print;
		
	end manager;
	
begin -- Primes
	PrimesFinished :=False;
	--put the first prime (2) into the initial filter
    Filter(1).Initialize(Position => 1, Divisor => 2);
	--enqueue from 3-1000 into the first buffer
	for counter in 3..HighInt loop
		Buffer(1).Enqueue(Counter);		
	end loop;
	--enqueue a zero into buffer one to signal the end of input
	Buffer(1).Enqueue(0);
	--wait until all the processing is finished
	while PrimesFinished = False loop
		null;
	end loop;
	--get the number of primes in Primes
	Primes.Size(i);
	Ada.Text_IO.Put("pos prime");
	Ada.text_iO.New_line;
	ada.text_iO.put("--- -----");
	Ada.text_iO.New_line;
	--get each prime from the buffer
	--print it's position and the prime itself
	for counter in 1..I loop
		Primes.Dequeue(p);
		Int_IO.put(counter, 3);
		Int_IO.Put(P, 6);
		Ada.Text_IO.New_Line;
	end loop;
	--Enqueue and Dequeue a zero to PRimes to end the task.
	Primes.Enqueue(0);
	Primes.Dequeue(P);
end Primes;
